// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.internal.taglib;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.component.UIStyle;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/** 
 * JSP Tag class, generated from template {@code tag1.2.stg} with class 
 * {@link org.apache.myfaces.tobago.internal.taglib.component.StyleTagDeclaration}.
 */
public final class StyleTag extends TobagoELTag {
  private static final Logger LOG = LoggerFactory.getLogger(StyleTag.class);
  private javax.el.ValueExpression  file;
  private javax.el.ValueExpression  style;

  @Override
  public String getComponentType() {
    return UIStyle.COMPONENT_TYPE;
  }
  @Override
  public String getRendererType() {
    return "Style";
  }

  @Override
  protected void setProperties(final UIComponent uiComponent) {
    super.setProperties(uiComponent);
    final UIStyle component = (UIStyle) uiComponent;
    final FacesContext context = FacesContext.getCurrentInstance();
    final Application application = context.getApplication();
    if (file != null) {
      component.setValueExpression("file", file);
    }

    if (style != null) {
      component.setValueExpression("style", style);
    }

  }

  public javax.el.ValueExpression getFile() {
    return file;
  }

  public void setFile(final javax.el.ValueExpression file) {
    this.file = file;
  }

  public javax.el.ValueExpression getStyle() {
    return style;
  }

  public void setStyle(final javax.el.ValueExpression style) {
    this.style = style;
  }


  @Override
  public int doAfterBody() throws javax.servlet.jsp.JspException {
    final String content = bodyContent.getString();
    bodyContent.clearBody();
    if (StringUtils.isNotBlank(content)) {
      final UIStyle component = (UIStyle) getComponentInstance();
      component.setStyle(content.trim());
    }
    return super.doAfterBody();
  }

  @Override
  public void release() {
    super.release();
    file = null;
    style = null;
  }
}